//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System;
using Tecan.Sila2;


namespace Tecan.Sila2.Interop.Server.UnobservableCommandTest
{
    
    
    /// <summary>
    /// Data transfer object for the request of the Command Without Parameters And Responses command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class CommandWithoutParametersAndResponsesRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public CommandWithoutParametersAndResponsesRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        public CommandWithoutParametersAndResponsesRequestDto(Tecan.Sila2.IBinaryStore store)
        {
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/UnobservableCommandTest/v1/Command/CommandWithoutParameters" +
                    "AndResponses";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return null;
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Convert Integer To String command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ConvertIntegerToStringRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.IntegerDto _integer;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ConvertIntegerToStringRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="integer">An integer, e.g. 12345</param>
        public ConvertIntegerToStringRequestDto(long integer, Tecan.Sila2.IBinaryStore store)
        {
            Integer = new Tecan.Sila2.IntegerDto(integer, store);
        }
        
        /// <summary>
        /// An integer, e.g. 12345
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto Integer
        {
            get
            {
                return _integer;
            }
            set
            {
                _integer = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/UnobservableCommandTest/v1/Command/ConvertIntegerToString";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Integer, "integer");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(Integer, "integer"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Convert Integer To String command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class ConvertIntegerToStringResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _stringRepresentation;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public ConvertIntegerToStringResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="stringRepresentation">The string representation of the given integer, e.g. '12345'</param>
        public ConvertIntegerToStringResponseDto(string stringRepresentation, Tecan.Sila2.IBinaryStore store)
        {
            StringRepresentation = new Tecan.Sila2.StringDto(stringRepresentation, store);
        }
        
        /// <summary>
        /// The string representation of the given integer, e.g. '12345'
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto StringRepresentation
        {
            get
            {
                return _stringRepresentation;
            }
            set
            {
                _stringRepresentation = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(StringRepresentation, "stringRepresentation");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(StringRepresentation, "stringRepresentation"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Join Integer And String command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class JoinIntegerAndStringRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.IntegerDto _integer;
        
        private Tecan.Sila2.StringDto _string;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public JoinIntegerAndStringRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="integer">An integer, e.g. 123</param>
        /// <param name="string">A string, e.g. 'abc'</param>
        public JoinIntegerAndStringRequestDto(long integer, string @string, Tecan.Sila2.IBinaryStore store)
        {
            Integer = new Tecan.Sila2.IntegerDto(integer, store);
            String = new Tecan.Sila2.StringDto(@string, store);
        }
        
        /// <summary>
        /// An integer, e.g. 123
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.IntegerDto Integer
        {
            get
            {
                return _integer;
            }
            set
            {
                _integer = value;
            }
        }
        
        /// <summary>
        /// A string, e.g. 'abc'
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.StringDto String
        {
            get
            {
                return _string;
            }
            set
            {
                _string = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/UnobservableCommandTest/v1/Command/JoinIntegerAndString";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(Integer, "integer");
            Argument.Validate(String, "string");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return (("" + Argument.Require(Integer, "integer")) 
                        + Argument.Require(String, "string"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Join Integer And String command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class JoinIntegerAndStringResponseDto : Tecan.Sila2.ISilaTransferObject
    {
        
        private Tecan.Sila2.StringDto _joinedParameters;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public JoinIntegerAndStringResponseDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="joinedParameters">Both parameters joined as string (e.g. '123abc')</param>
        public JoinIntegerAndStringResponseDto(string joinedParameters, Tecan.Sila2.IBinaryStore store)
        {
            JoinedParameters = new Tecan.Sila2.StringDto(joinedParameters, store);
        }
        
        /// <summary>
        /// Both parameters joined as string (e.g. '123abc')
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto JoinedParameters
        {
            get
            {
                return _joinedParameters;
            }
            set
            {
                _joinedParameters = value;
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(JoinedParameters, "joinedParameters");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(JoinedParameters, "joinedParameters"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the request of the Split String After First Character command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class SplitStringAfterFirstCharacterRequestDto : Tecan.Sila2.ISilaTransferObject, Tecan.Sila2.ISilaRequestObject
    {
        
        private Tecan.Sila2.StringDto _string;
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        public SplitStringAfterFirstCharacterRequestDto()
        {
        }
        
        /// <summary>
        /// Create a new instance
        /// </summary>
        /// <param name="store">An object to organize binaries.</param>
        /// <param name="string">A string, e.g. 'abcde'</param>
        public SplitStringAfterFirstCharacterRequestDto(string @string, Tecan.Sila2.IBinaryStore store)
        {
            String = new Tecan.Sila2.StringDto(@string, store);
        }
        
        /// <summary>
        /// A string, e.g. 'abcde'
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto String
        {
            get
            {
                return _string;
            }
            set
            {
                _string = value;
            }
        }
        
        /// <summary>
        /// Gets the command identifier for this command
        /// </summary>
        /// <returns>The fully qualified command identifier</returns>
        public string CommandIdentifier
        {
            get
            {
                return "org.silastandard/test/UnobservableCommandTest/v1/Command/SplitStringAfterFirstCha" +
                    "racter";
            }
        }
        
        /// <summary>
        /// Validates the given request object
        /// </summary>
        public void Validate()
        {
            Argument.Validate(String, "string");
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            return ("" + Argument.Require(String, "string"));
        }
    }
    
    /// <summary>
    /// Data transfer object for the response of the Split String After First Character command
    /// </summary>
    [ProtoBuf.ProtoContractAttribute()]
    public class SplitStringAfterFirstCharacterResponseDto : Tecan.Sila2.ISilaTransferObject<SplitStringAfterFirstCharacterResponse>
    {
        
        private Tecan.Sila2.StringDto _firstCharacter;
        
        private Tecan.Sila2.StringDto _remainder;
        
        /// <summary>
        /// Initializes a new instance (to be used by the serializer)
        /// </summary>
        public SplitStringAfterFirstCharacterResponseDto()
        {
        }
        
        /// <summary>
        /// Initializes a new data transfer object from the business object
        /// </summary>
        /// <param name="inner">The business object that should be transferred</param>
        /// <param name="store">A component to handle binary data</param>
        public SplitStringAfterFirstCharacterResponseDto(SplitStringAfterFirstCharacterResponse inner, Tecan.Sila2.IBinaryStore store)
        {
            FirstCharacter = new Tecan.Sila2.StringDto(inner.FirstCharacter, store);
            Remainder = new Tecan.Sila2.StringDto(inner.Remainder, store);
        }
        
        /// <summary>
        /// The first character, e.g. 'a', or an empty string if the input was empty
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(1)]
        public Tecan.Sila2.StringDto FirstCharacter
        {
            get
            {
                return _firstCharacter;
            }
            set
            {
                _firstCharacter = value;
            }
        }
        
        /// <summary>
        /// The remainder, e.g. 'bcde', or an empty string if the input was shorter that two characters
        /// </summary>
        [ProtoBuf.ProtoMemberAttribute(2)]
        public Tecan.Sila2.StringDto Remainder
        {
            get
            {
                return _remainder;
            }
            set
            {
                _remainder = value;
            }
        }
        
        /// <summary>
        /// Extracts the transferred value
        /// </summary>
        /// <param name="store">The binary store in which to store binary data</param>
        /// <returns>the inner value</returns>
        public SplitStringAfterFirstCharacterResponse Extract(Tecan.Sila2.IBinaryStore store)
        {
            return new SplitStringAfterFirstCharacterResponse(FirstCharacter.Extract(store), Remainder.Extract(store));
        }
        
        /// <summary>
        /// Creates the data transfer object from the given object to transport
        /// </summary>
        /// <param name="inner">The object to transfer</param>
        /// <param name="store">An object to store binary data</param>
        public static SplitStringAfterFirstCharacterResponseDto Create(SplitStringAfterFirstCharacterResponse inner, Tecan.Sila2.IBinaryStore store)
        {
            return new SplitStringAfterFirstCharacterResponseDto(inner, store);
        }
        
        /// <summary>
        /// Validates the contents of this transfer object
        /// </summary>
        /// <returns>A validation error or null, if no validation error occurred.</returns>
        public string GetValidationErrors()
        {
            string errors = (("" + Argument.Require(FirstCharacter, "firstCharacter")) 
                        + Argument.Require(Remainder, "remainder"));
            if ((FirstCharacter.Value.Length > 1))
            {
                errors = (errors + string.Format("FirstCharacter  has length {0} and is longer than allowed length 1", FirstCharacter.Value.Length));
            }
            return errors;
        }
    }
}
